Subject: RE: Lots of "BUG eth1 code -5 qlen 0" messages in 2.6.24

From: jamal <[email-masked]>
Date: Tue, 29 Jan 2008 15:57:23 -0500

On Tue, 2008-29-01 at 11:57 -0800, Waskiewicz Jr, Peter P wrote:
> > I've just started to use 2.6.24 on my home firewall (before 
> > it was running 2.6.24-rc2 for about 65 days) and I noticed a 
> > couple of error messages I've never seen before:
> > 
> > Jan 29 07:50:54 gateway kernel: BUG eth1 code -5 qlen 0 Jan 
> > 29 08:28:30 gateway kernel: BUG eth1 code -5 qlen 0 Jan 29 
> > 08:57:30 gateway kernel: BUG eth1 code -5 qlen 0 Jan 29 
> > 09:44:04 gateway kernel: BUG eth1 code -5 qlen 0 Jan 29 
> > 10:01:35 gateway kernel: BUG eth1 code -5 qlen 0 Jan 29 
> > 10:01:35 gateway last message repeated 2 times Jan 29 
> > 10:16:48 gateway kernel: BUG eth1 code -5 qlen 0 Jan 29 
> > 10:16:48 gateway last message repeated 2 times Jan 29 
> > 10:45:48 gateway kernel: BUG eth1 code -5 qlen 0 Jan 29 
> > 10:45:48 gateway last message repeated 2 times Jan 29 
> > 11:10:01 gateway kernel: BUG eth1 code -5 qlen 0 Jan 29 
> > 11:10:02 gateway last message repeated 9 times
> > 
> > The message seems to be coming from the qdisc_restart() in 
> > net/sched/sch_generic.c which was changed with commit 
> > 5f1a485d5905aa641f33009019b3699076666a4c .
> > 
> > The NIC is an IBM EtherJet cardbus card using the xircom_cb driver:
> 
> Are you using any specific qdisc, or just the default pfifo_fast?  Have
> you done any specific tuning on your qdisc as well?  The default qlen
> seems to have been changed.

The driver seems buggy. Make it return NETDEV_TX_BUSY instead of -EIO
in xircom_start_xmit() and the messages will go away.

cheers,
jamal